 
 package Spe124;

################################################################
###                                                          ###
### SCaFoS                                                   ###
### gestion de la creation des fichiers .otu                 ###
###                                                          ###
################################################################
### Version 4.40 du 2006/08/28                           BPH ###
################################################################


 use strict;
 use warnings;

 use Var124;
 use Lib124;
 use Gub124;

 use vars qw(@ISA @EXPORT);
 require Exporter;
 @ISA = qw(Exporter);
 @EXPORT = qw/ GetSpec /;


################################################################


 my $L;
 my $bAff;
 
 
### ecriture du fichier .otu ###################################
sub GetSpec {
    my $FileName;
         
    ### Determine les especes suffisamment presentes ###
    if ( $FlagIHM == 1 ) { ViewCurrent('Search species', 'darkblue', $Current ) }; 

    RetainedSpecies();
    
    ### On ouvre en ecriture le fichier resultat ###
    if ( !open(LOG,"> $NameCef.log") ) { AffError("Can\'t open for writing the file \'$NameCef.log\' !"); }
    print LOG "-----------------------------------------------------------------------\n";
    print LOG " In directory : $FileRep\n";
    print LOG " Out directory : $CefRep\n";
    print LOG " ".scalar(localtime(time()))." \n\n";
    ### Recherche doublons d especes et especes absentes ###
    if ( $FlagIHM == 1 ) { ViewCurrent('Search missing species', 'darkblue', $Current ) }
    GetDblAndAbs();
    ### affiche le taux de presence d une espece dans tous les fichiers ###
    print LOG "\n-----------------------------------------------------------------------\n";
    print LOG " Frequency in file for each specie :\n\n";
    for my $E ( sort { $FreqSpec{$b} <=> $FreqSpec{$a} || $a cmp $b } keys %FreqSpec ) {
        $L = ((100 * $FreqSpec{$E}) / $NbFileAli)."%";
        $L = pack("A2A25A3A4", " ", $E, " : ", $L);
        print LOG "$L\n";
        }
    print LOG @Resume;
    print LOG "\n\n-----------------------------------------------------------------------\n";
    print LOG " Maximum lenght of sequences for each aligned file :\n\n";
    my $Sum = 0;
    for $L ( sort keys %FicLen ) {
        $Sum += $FicLen{$L};
        $FileName = $L;
        if ( $TypeAli ne '.ali' ) { $FileName =~ s/\.ali//; }
        print LOG "   ".pack("A25A6", $FileName, $FicLen{$L})."\n";
        }
    print LOG " Sum of length : $Sum\n\n";
    print LOG "\n\n=======================================================================\n\n";
    close LOG;
    ### Liste les especes dans les fichiers dir-xxxx.otu ###
    $bAff = "\n\n Writing of OTUs files:";
    if ( $FlagIHM == 1 ) { 
        ViewCurrent($bAff, 'darkblue', $Current);
        if ( $FlagVerb ) {$Details -> insert( 'end', $bAff); $Details -> update; $Details -> see('end'); }
        }
    else { print $bAff; }
    WriteListSpecies();
    ### Affichage du resume ###
    if ( $FlagIHM == 1 ) {
        if ( $#ARGV >= 2 ) {
            for ( @Resume ) { $Details -> insert ( 'end' , $_ ); }
            }
        $Details -> insert ( 'end' , "\n Details of the results in file: $NameCef.log\n" );
        $Details -> insert ( 'end' , "=======================================================================\n\n");
        $Details -> update; 
        }
    else {
        if ( $#ARGV >= 2 ) { print @Resume; }
        $L = "\n\n Details of the results in file: $NameCef.log\n";
        $L .= "=======================================================================\n\n\n";
        print $L;
        }
}


### Determine les especes a prendre en compte ##################
sub RetainedSpecies {
    my $ListEsp = '';
    my $b = '';
    my $c = '';
    my $E;
    my $n;
    my $F;
    
    #-- Gestion des sequences a retenir ------------------------
    for $E ( keys %FreqSpec ) {
        $n = 0;
        $b = "<<<<<" . $E . "<<<<<";
        for $F ( keys %Fichiers ) {
            $ListEsp = "<<<<<" . join("<<<<<", @{$Fichiers{$F}}) . "<<<<<";
            $n++ if ( $ListEsp =~ m/$b/ ) ;     # compte nombre apparitions de l espece
            }
        if ( (100 * $n / $NbFileAli) >= $TauxMin ) {
            # sauvegarde l espece dont le taux de presence est suffisant
            $FreqSpec{$E} = $n;
            $nbSpe++;
            }
        else {
            # supprime l espece dont le taux de presence est trop faible
            delete($FreqSpec{$E});
            }
        }
    $L = " Number of species retained: $nbSpe / $NbEspTot\n\n";
    push (@Resume, $L);
}


### Doublons et absences #######################################
sub GetDblAndAbs {
    $L = "-----------------------------------------------------------------------\n";
    $L .= pack("A20A10A10A10A10", "File", "Nb Seq", "Nb Spe", "Nb Dbl", "Nb Abs");
    push (@Resume, "\n$L\n\n");

    my $b = '';
    my $ListEsp = '';
    my $FileName;
    for my $F ( sort keys %Fichiers ) {
        $FileName = $F;
        if ( $TypeAli ne '.ali' ) { $FileName =~ s/\.ali//; }
        ### recherche les doublons d'especes pour chaque fichier ####
        my $NbD = 0;
        my $NbSeq = 0;
        my $NbEsp = 0;
        $ListEsp = join("<<<<<", @{$Fichiers{$F}}) . "<<<<<";
        $L = "";
        for my $E ( sort @{$Fichiers{$F}} ) {
            $NbSeq++;                        # compte nombre de sequences dans le fichier
            if ( exists($FreqSpec{$E}) ) {
                # $E est une espece au taux de presence correct
                my $n = 0;
                $b = "<<<<<" . $E . "<<<<<";
                if ( !($L =~ m/$E\s+/) ) {      # nouvelle espece
                    $NbEsp++;                # compte nombre d especes du le fichier etudiees
                    $n++ while ( $ListEsp =~ m/$b/g );    # compte nombre apparitions du motif
                    if ( $n > 1 )            # cas d un doublon
                        { $L .= pack("A40", "    $E ($n)") . (++$NbD % 2 ? "" : "\n"); }
                    }
                }
            }
        # affiche les doublons
        print LOG "\n-----------------------------------------------------------------------\n";
        print LOG "$FileName\n\n * $NbSeq sequences in file\n";
        if ( $NbD == 0)
            { print LOG " * Twice :\n"; }
        else {
            print LOG "\n * Twice : $NbD species at least 2 time in file\n$L\n";
            print LOG ($NbD % 2 ? "\n" : "");
            }

        ### recherche les especes manquantes pour chaque fichier ###
        my $NbA = 0;
        $L = "";
        for my $E ( sort keys %FreqSpec ) {
            $b = "<<<<<" . $E . "<<<<<";
            if ( !($ListEsp =~ m/$b/) ) {
                if ( !($L =~ m/$E\s+/) )
                    { $L .= pack("A40", "    ".$E) . (++$NbA % 2 ? "" : "\n"); }
                }
            }
        # affiche les absences
        if ( $NbA == 0)
            { print LOG " * Missing :\n"; }
        else {        
            print LOG " * Missing : $NbA species not in file or with a shorter sequence\n$L\n";
            print LOG ($NbA % 2 ? "\n" : "");
            }
        # sauvegarde resume
        $L = pack("A20A10A10A10A10", $FileName, $NbSeq, $NbEsp, $NbD, $NbA)."\n";
        push (@Resume, $L);
        }
}


my %hSpe;    # hachage { espece => taxon }
my %hTaxa;   # hachage { taxon => liste des especes separees par ','}

### Lecture du fichier d'especes a extraire ####################
sub ReadName {
    my $Taxa;
    my $Spe;
    my @E;
    
    if ( !(open FIC, $NameFile) ) { AffError("Can't open for reading the file \'$NameFile\'"); }

    #-- Lecture du fichier ligne a ligne -----------------------
    while ( $L = <FIC> ) {
        if ( $L =~ m/(.*),(.*)/ ) {
            $Spe = $1;
            $Taxa = $2;
            # recupere nom espece
            $Spe =~ s/^\s*//;
            $Spe =~ s/\s*$//;
            # recupere nom de taxon
            $Taxa =~ s/^\s+//;
            $Taxa =~ s/\s+$//;
            # stocke les especes retenues avec correspondance du taxon
            $hSpe{$Spe} = $Taxa;
            $hTaxa{$Taxa} .= $Spe.',';
            }
        }
    close FIC;
# foreach (sort keys %hTaxa) {print "$_\n";}
}


### Ecrit les especes dans le fichier dir1.otu #################
sub WriteInSpeFreq{
    my ($Seq2, $flag) = @_;
    my $buf = "";
    
    # ajout des blanc endebut de ligne
    if ( $flag > 0 ) { 
        $flag *= 2;
        $buf = pack("A$flag", ' '); 
        }
    # ecriture du % dans le fichier .otu
    $L = sprintf("%.0f", (100 * $FreqSpec{$Seq2}) / $NbFileAli);
    if ( exists($hSpe{$Seq2}) )
        { print SPE "$buf$Seq2 : $Seq2 ($L% - $hSpe{$Seq2})\n"; }
    else
        { print SPE "$buf$Seq2 : $Seq2 ($L%)\n"; }
    $nbSpe++;
    # retourne le % calcule pour ecritures dans .otu suivants
    # et la liste des sequences deja trouvees
    return($L);
}


sub WriteInSpeTaxa{
    my ($Seq2, $flag) = @_;
    my $buf = "";
    
    # ajout des blanc endebut de ligne
    if ( $flag > 0 ) { 
        $flag *= 2;
        $buf = pack("A$flag", ' '); 
        }
    # renvoie du % et de la ligne a ecrire dans le fichier .otu
    $nbSpe++;
    $L = sprintf("%.0f", (100 * $FreqSpec{$Seq2}) / $NbFileAli);
    return($L, "$buf$Seq2 : $Seq2 ($L%)\n");
}


sub WriteListSpecies {
    my $bSeq = '';
    my $Nom = '';
    my $buf = '';
    my $Seq = '';
    my $Seq2 = '';
    my $c = '';
    my @l;
    my $bN;
    my $bS;
    my @lSeq;
    my @lNew;
    my $flag;
    my %FS;

    #-- Lecture des taxons -------------------------------------
    if ( $NameFile ne "" ) { ReadName(); }

    #-- Supprime blanc en debut et fin de nom d'espece ---------
    @l = sort { $FreqSpec{$b} <=> $FreqSpec{$a} } keys %FreqSpec;     #tri par frequence decroissante
    for $Seq ( @l ) {
        if ( length($Seq) ) {
            $Seq =~ s/^\s*//;
            $Seq =~ s/\s*$//;
            push @lSeq, $Seq;
            }
        }
    @l = [];
    
    #-- Affichage par ordre de frequence decroissant -----------
    $bAff = "\n\n   Writing of species file in frequency order\n";
    if ( $FlagIHM ) {
        ViewCurrent($bAff, 'darkblue', $Current );        
        $Details -> insert( 'end', $bAff); 
        $Details -> update; $Details -> see('end'); 
        }
    else { print $bAff; }
    $L = $NameCef."-freq.otu";
    if ( !(open SPE, "> $L") ) { AffError("Can't open for writing the file \'$L\'"); }
    print SPE "# List of species (frequency's order)\n# Minimal frequency = ".$TauxMin."%\n#\n";
    $bSeq = "<<<<<";
    for $Seq ( @lSeq ) {
       # determine nom espece
        $Nom = SearchSpecName($Seq, "_");       # supprime nom de souche
        if ( $FlagVerb ) {
            if ( $FlagIHM ) 
                {$Details -> insert( 'end', "   === $Nom ===\n"); $Details -> update; $Details -> see('end'); }        
            else { print "   === $Nom ===\n"; }
            }
        # selectionne toutes les sequences avec meme nom d'espece
        $flag = 0;
        for $Seq2 ( @lSeq ) {
            # on passe sequences deja traitees 
            if ( $bSeq =~ m/<<<<<$Seq2<<<<</ ) { next; }
            if ( $Seq2 eq $Seq ) {
                # on est arrive a la seq de freq max
                $FS{$Seq2} = WriteInSpeFreq($Seq2, $flag);
                $bSeq .= ($Seq2 . "<<<<<");
                $flag = 1;
                next;
                }
            if ( $flag == 0 ) { next; }
            # la seq courante contient le nom d'espece
# 4.40            if ( $Seq2 =~ m/^$Nom/ ) {
            if ( $Seq2 eq $Nom ) {
                $FS{$Seq2} = WriteInSpeFreq($Seq2, $flag);
                $bSeq .= ($Seq2 . "<<<<<");
                }
            }
        }
    close SPE;
    $L = "   List of species in frequency order in file :  $NameCef-freq.otu\n";
    if ( $FlagIHM == 1 ) { $Details -> insert( 'end', $L); $Details -> update; }
    else { print $L; }
    
    #-- Affichage par ordre alphabetique -----------------------
    $bAff = "\n   Writing of species file in alphabetic order\n";
    if ( $FlagIHM ) {
        ViewCurrent($bAff, 'darkblue', $Current );        
        $Details -> insert( 'end', $bAff); 
        $Details -> update; $Details -> see('end'); 
        }        
    else { print $bAff; }
    $L = $NameCef."-name.otu";
    if ( !(open SPE, "> $L") ) { AffError("Can't open for writing the file \'$L\'"); }
    print SPE "# List of species (alphabetic order)\n# Minimal frequency = ".$TauxMin."%\n#\n";
    for $Seq ( sort @lSeq ) {
        $L = $FS{$Seq};
        $buf = $Seq;
        if ( exists($hSpe{$Seq}) )
            { print SPE "$buf : $buf ($L% - $hSpe{$Seq})\n"; }
        else
            { print SPE "$buf : $buf ($L%)\n"; }
        
        if ( $FlagVerb ) {
            if ( $FlagIHM ) 
                {$Details -> insert( 'end', "   === $Seq ===\n"); $Details -> update; $Details -> see('end'); }        
            else { print "   === $Seq ===\n"; }
            }
        }
    close SPE;
    $L = "   List of species in alphabetic order in file : $NameCef-name.otu\n";
    if ( $FlagIHM == 1 ) { $Details -> insert( 'end', $L); $Details -> update; }
    else { print $L; }

    #-- Affichage par ordre de frequence decroissant par taxon -
    if ( $NameFile ne '' ) {
        $bAff = "\n   Writing of species file in taxa order\n";
        if ( $FlagIHM ) {
            ViewCurrent($bAff, 'darkblue', $Current );        
            $Details -> insert( 'end', "$bAff"); 
            $Details -> update; $Details -> see('end'); 
            }        
        else 
            { print $bAff; }
        $L = $NameCef."-taxa.otu";
        if ( !(open SPE, "> $L") ) { AffERror("Can't open for writing the file \'$L\'"); }
        print SPE "# List of species grouped by taxa\n# Minimal frequency = ".$TauxMin."%\n";
        $bSeq = "<<<<<";
        my $T;               # taxon courant
        my $bNoTaxa;         # nom de sequence dont l'espece n'est pas associee a un taxon
        my $L2;        
        my @lSpeTaxa;        # liste des sequences d'un taxon
        my %hSeqSpe = ();    # hachage des sequences par espece : 
                             #  ( espece => { sequence => frequence } )
        my %hFreqMax = ();   # hachage des frequences max par espece : 
                             #  ( espece => frequence max )
        my %hTmp;            # hachage temporaire : ( sequence => frequence )
        my $Spe;             # nom de l'espece
        my $FreqMax;         # frequence maximale pour une espece
        my %hSortFS = ();    # hachage pour tri des especes par frequence max
                             #  ( espece => buffer des sequences pour l'espece )

        #-- regroupement des nom de sequences par espece
        for $Seq ( @lSeq ) {
            # supprime identifiant de souche
            if ( $Seq =~ m/_/ )
                { $Spe = SearchSpecName($Seq, "_"); }
            else
                { $Spe = $Seq; }
            # recupere sequences deja trouvees pour cette espece
            %hTmp = ();
            if ( exists($hSeqSpe{$Spe}) ) {
                %hTmp = @{$hSeqSpe{$Spe}[0]};
                $FreqMax = $hFreqMax{$Spe};
                }
            else {
                $FreqMax = -1;
                }
            # ajoute sequence a la liste des sequences de lespece
            $hTmp{$Seq} = $FS{$Seq};
            @{$hSeqSpe{$Spe}[0]} = %hTmp;
            # maj frequence max pour lespece
            if ( $FS{$Seq} > $FreqMax ) { $hFreqMax{$Spe} = $FS{$Seq}; }
            if ( $FlagVerb ) {
                if ( $FlagIHM ) 
                    {$Details -> insert( 'end', "   === $Seq ===\n"); $Details -> update; $Details -> see('end'); }        
                else 
                    { print "   === $Seq ===\n"; }
                }
            }

        #-- chaine des especes non presentes dans un taxon
        $bNoTaxa = "<<<<<" . join("<<<<<", @lSeq) . "<<<<<";

        #-- classement des especes par taxon
        for $T ( sort keys %hTaxa ) {
            if ( length($T) == 0 ) { next; }
            # liste des especes pour le taxon courant
            @lSpeTaxa = split(',', $hTaxa{$T});
            %hSortFS = ();
            for $Spe ( @lSpeTaxa ) {
                %hTmp = ();
                # supprime identifiant de souche
                if ( $Spe =~ m/_/ )
                    { $Spe = SearchSpecName($Spe, "_"); }
                if ( exists($hSeqSpe{$Spe}) ) {
                    %hTmp = @{$hSeqSpe{$Spe}[0]};
                    # tri les sequences par ordre decroissant de frequences
                    @l = sort { $hTmp{$b} <=> $hTmp{$a} } keys %hTmp;
                    $flag = 1;
                    $buf = '';
                    for $Seq ( @l ) {
                        # 1ere sequence de lespece
                        if ( $flag == 1 ) {
                            ($L2, $L) = WriteInSpeTaxa($Seq, $flag);
                            $flag = 2;
                            }
                        # sequences suivantes
                        else {
                            ($L2, $L) = WriteInSpeTaxa($Seq, $flag);
                            }
                        $buf .= $L;
                        # supprime sequence de la liste des sequences non presentes
# 4.40                        $bNoTaxa =~ s/$Seq<<<<<//;
                        $bNoTaxa =~ s/<<<<<$Seq<<<<</<<<<</;
                        }
                    @{$hSortFS{$Spe}[0]} = $buf;
                    }
                 }
                
            # ecrit les especes par ordre deroissant de frequence
            @l = keys(%hSortFS);
            if ( $#l != -1 ) { 
                print SPE "#\n# $T\n";
                @l = sort { $hFreqMax{$b} <=> $hFreqMax{$a} } keys %hFreqMax;
                for $Spe ( @l ) {
                    if ( exists $hSortFS{$Spe} ) { print SPE @{$hSortFS{$Spe}[0]}; }
                    $flag = 1;
                    }
                }
            }

        #-- Ecriture des sequences non trouvees dans un taxon --
        $buf = "";
        if ( $bNoTaxa ne "<<<<<" ) {
            $buf = "#\n# Undefined taxa\n";
            $bNoTaxa =~ s/^<<<<<//;
            $bNoTaxa =~ s/<<<<<$//;
            @l = split("<<<<<", $bNoTaxa);
            $Spe = '';
            for $Seq (sort @l) {
                if ( length($Seq) > 0 ) {
                    # supprime identifiant de souche
                    $L = SearchSpecName($Seq, "_");
                    # formatte sortie
                    if ( $L eq $Spe )
                        { ($L2, $L) = WriteInSpeTaxa($Seq, 2); }
                    else {
                        $Spe = $L;
                        ($L2, $L) = WriteInSpeTaxa($Seq, 1);
                        }
                    $buf .= $L;
                    if ( $FlagVerb ) {
                        if ( $FlagIHM ) 
                            {$Details -> insert( 'end', "   === $Seq ===\n"); $Details -> update; $Details -> see('end'); }        
                        else 
                            { print "   === $Seq ===\n"; }
                        }
                    }
                }
            }
        # si au moins une sequence, on l'ecrit dans .otu
        if ( $buf ne "" ) { print SPE $buf; }
        
        close SPE;
        $L = "   List of species grouped by taxa in file :     $NameCef-taxa.otu\n\n";
        if ( $FlagIHM == 1 ) { $Details -> insert( 'end', $L); $Details -> update; }
        else { print $L; }
        }
}


 1;


### fin du fichier                                           ###
################################################################
